//+------------------------------------------------------------------+
//|                                                  EMABands_v2.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                    Modified by Bogie Enterprises |                                    
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Aqua
#property indicator_color3 Red


//---- input parameters
extern int Length=3; // Length is averaging periods for calculation
extern int MA_mode=1;   // 0=SMA, 1=EMA, 2=SMMA, 3=LWMA
extern int Delta=15; // Delta is pip distance above and below iMA() baseline

//---- indicator buffers
double UpBuffer1[];
double UpBuffer2[];
double DnBuffer1[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   

   SetIndexBuffer(0,UpBuffer1);
   SetIndexBuffer(1,UpBuffer2);
   SetIndexBuffer(2,DnBuffer1);
   
//---- name for DataWindow and indicator subwindow label
   short_name="EMABands("+Length+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Up1");
   SetIndexLabel(1,"Up2");
   SetIndexLabel(2,"Dn1");
   
//----
   SetIndexDrawBegin(0,Length);
   SetIndexDrawBegin(1,Length);
   SetIndexDrawBegin(2,Length);
   
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| EMABands_v1                                                     |
//+------------------------------------------------------------------+
int start()
  {
   
   int shift,limit, counted_bars=IndicatorCounted();
   
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-Length-1; 
     
	for(shift=limit;shift>=0;shift--) 
   {	
   UpBuffer1[shift] = iMA(NULL,0,Length,0,MA_mode,PRICE_CLOSE,shift);
   UpBuffer2[shift] = UpBuffer1[shift] + Delta*Point;
	
   DnBuffer1[shift] = UpBuffer1[shift] - Delta*Point;
	}
	return(0);	
 }

